/* static char TMSMRaster_h[] = "<%W%	%D% %T%>"; */
/*
 * 			Copyright 1993, 1994 by AT&T
 * 
 * 			 All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of AT&T not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * AT&T DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * AT&T BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 * 
 * AT&T's dontation of this software does not imply a licence granted for
 * patents nor transfer of ownership of any patents which may inadvertently
 * be implemented in this code.
 * 
 */

/*************************************<+>*************************************
 *****************************************************************************
 **
 **   File:        SMRaster.h
 **
 **   Project:     X Widgets
 **
 **   Description: Public include file for Static Raster class widget
 **
 *****************************************************************************
 **   
 **   Copyright (c) 1988 by Hewlett-Packard Company
 **   Copyright (c) 1988 by the Massachusetts Institute of Technology
 **   
 **   Permission to use, copy, modify, and distribute this software 
 **   and its documentation for any purpose and without fee is hereby 
 **   granted, provided that the above copyright notice appear in all 
 **   copies and that both that copyright notice and this permission 
 **   notice appear in supporting documentation, and that the names of 
 **   Hewlett-Packard or  M.I.T.  not be used in advertising or publicity 
 **   pertaining to distribution of the software without specific, written 
 **   prior permission.
 **   
 *****************************************************************************
 *************************************<+>*************************************/


/*  Static Magnifying Raster Widget  */

extern WidgetClass XwsmrasterWidgetClass;

typedef struct _XwSMRasterClassRec * XwSMRasterWidgetClass;
typedef struct _XwSMRasterRec      * XwSMRasterWidget;


/*  synonyms added for consistent naming conventions */

extern WidgetClass XwstaticMagnifyingRasterWidgetClass;

typedef struct _XwSMRasterClassRec * XwStaticMagnifyingRasterWidgetClass;
typedef struct _XwSMRasterRec      * XwStaticMagnifyingRasterWidget;

#define XtNsMRmagnification	"magnification"
#define XtCSMRmagnification	"Magnification"

#ifdef ATHENA

#ifndef XrmRImage
#define XrmRImage          "Image"
#endif

#ifndef XtNsRimage
#define XtNsRimage         "rasterImage"
#endif

#ifndef XtCSRimage
#define XtCSRimage         "RasterImage"
#endif

#ifndef XtRImage
#define XtRImage           XrmRImage
#endif

#ifndef XtNimage
#define XtNimage           "image"
#endif

#ifndef XtCImage
#define XtCImage           "Image"
#endif

#ifndef XtNinvertOnSelect
#define XtNinvertOnSelect  "invertOnSelect"
#endif

#ifndef XtCInvertOnSelect
#define XtCInvertOnSelect  "InvertOnSelect"
#endif

#ifndef XtNshowSelected
#define XtNshowSelected    "showSelected"
#endif

#ifndef XtCShowSelected
#define XtCShowSelected    "ShowSelected"
#endif

#ifndef XtNset
#define XtNset         "set"
#endif

#ifndef XtCSet
#define XtCSet         "Set"
#endif

#ifndef XtNselect
#define XtNselect         "select"
#endif

#ifndef XtNrelease
#define XtNrelease         "release"
#endif

#endif /* ATHENA */

#ifdef MOTIF

#ifndef XrmRImage
#define XrmRImage          "Image"
#endif

#ifndef XtNsRimage
#define XtNsRimage         "rasterImage"
#endif

#ifndef XtCSRimage
#define XtCSRimage         "RasterImage"
#endif

#ifndef XtRImage
#define XtRImage           XrmRImage
#endif

#ifndef XtNimage
#define XtNimage           "image"
#endif

#ifndef XtCImage
#define XtCImage           "Image"
#endif

#ifndef XtNinvertOnSelect
#define XtNinvertOnSelect  "invertOnSelect"
#endif

#ifndef XtCInvertOnSelect
#define XtCInvertOnSelect  "InvertOnSelect"
#endif

#ifndef XtNshowSelected
#define XtNshowSelected    "showSelected"
#endif

#ifndef XtCShowSelected
#define XtCShowSelected    "ShowSelected"
#endif

#ifndef XtNset
#define XtNset         "set"
#endif

#ifndef XtCSet
#define XtCSet         "Set"
#endif

#ifndef XtNselect
#define XtNselect         "select"
#endif

#ifndef XtNrelease
#define XtNrelease         "release"
#endif

#endif /* MOTIF */

#ifdef OPENLOOK

#ifndef XrmRImage
#define XrmRImage          "Image"
#endif

#ifndef XtNsRimage
#define XtNsRimage         "rasterImage"
#endif

#ifndef XtCSRimage
#define XtCSRimage         "RasterImage"
#endif

#ifndef XtRImage
#define XtRImage           XrmRImage
#endif

#ifndef XtNimage
#define XtNimage           "image"
#endif

#ifndef XtCImage
#define XtCImage           "Image"
#endif

#ifndef XtNinvertOnSelect
#define XtNinvertOnSelect  "invertOnSelect"
#endif

#ifndef XtCInvertOnSelect
#define XtCInvertOnSelect  "InvertOnSelect"
#endif

#ifndef XtNshowSelected
#define XtNshowSelected    "showSelected"
#endif

#ifndef XtCShowSelected
#define XtCShowSelected    "ShowSelected"
#endif

#ifndef XtNrelease
#define XtNrelease         "release"
#endif

#endif /* OPENLOOK */

#include "C_P_args.h"
C_PROTOS_BEGIN_EXTERN

extern void
UnmapSMRasterWidget C_P_ARGS((XwSMRasterWidget w));

extern void
MapSMRasterWidget C_P_ARGS((XwSMRasterWidget w));

C_PROTOS_END_EXTERN
